Index: /trunk/src/cf_codec.c
===================================================================
--- /trunk/src/cf_codec.c	(revision 71)
+++ /trunk/src/cf_codec.c	(revision 72)
@@ -17,4 +17,6 @@
 #define IS_UPPERCASE(x)		(x >= 'A' && x <= 'F')
 
+typedef	unsigned char __uchar;
+
 /**
  * 바이너리 데이터를 16진수 문자열로 변환
@@ -33,13 +35,13 @@
 					  char					* hex)
 {
-	size_t	iter = 0;
-	size_t	count = len * 2 + 1;
+	size_t		iter = 0;
+	size_t		count = len * 2 + 1;
 
-	char	hexchar[] = {'0', '1', '2', '3',
-						 '4', '5', '6', '7',
-						 '8', '9', 'a', 'b',
-						 'c', 'd', 'e', 'f'};
+	const char	hexchar[] = {'0', '1', '2', '3',
+							 '4', '5', '6', '7',
+							 '8', '9', 'a', 'b',
+							 'c', 'd', 'e', 'f'};
 
-	const unsigned char	* ptr = bin;
+	const __uchar	* ptr = bin;
 
 	ASSERT_ARGS (bin == NULL);
@@ -72,6 +74,4 @@
 					  size_t		* len)
 {
-	typedef	unsigned char __uchar;
-
 	int		result = 0;
 
Index: /trunk/test/codec.c
===================================================================
--- /trunk/test/codec.c	(revision 71)
+++ /trunk/test/codec.c	(revision 72)
@@ -16,14 +16,13 @@
 	size_t length = 0;
 
-	CF_DEBUG_PRINT (stderr, " = Convert binary to hex = \n");
+	CF_DEBUG_PRINT (stderr, "data   : %s\n", data);
+	CF_DEBUG_PRINT (stderr, "= Convert binary to hex =\n");
 	CF_Codec_BinaryToHex ((unsigned char *)data, strlen (data), hex);
-	CF_DEBUG_PRINT (stderr, "data : %s\n", data);
-	CF_DEBUG_PRINT (stderr, "hex : %s\n", hex);
-	CF_DEBUG_PRINT_BIN (stderr, (unsigned char *) data, strlen (data), "data : %s\n", data);
+	CF_DEBUG_PRINT (stderr, "hex    : %s\n", hex);
+	CF_DEBUG_PRINT_BIN (stderr, (unsigned char *) data, strlen (data), "data   : %s\n", data);
 
-	CF_DEBUG_PRINT (stderr, " = Convert hex to binary = \n");
+	CF_DEBUG_PRINT (stderr, "= Convert hex to binary =\n");
 	CF_Codec_HexToBinary (hex, bin, &length);
-	CF_DEBUG_PRINT (stderr, "bin : %s\n", bin);
-	CF_DEBUG_PRINT_BIN (stderr, bin, length, "bin : %s\n", bin);
+	CF_DEBUG_PRINT_BIN (stderr, bin, length, "bin    : %s\n", bin);
 
 	return 0;
Index: /trunk/test/test.c
===================================================================
--- /trunk/test/test.c	(revision 71)
+++ /trunk/test/test.c	(revision 72)
@@ -238,5 +238,5 @@
 	CF_Log_Write (LOG_SOCKET, "SERVER", "accepted\n");
 
-	for (i = 0 ; i < 100 ; i++)
+	for (i = 0 ; i < 10 ; i++)
 	{
 		if ((recvd = CF_Socket_Recv (clntsock, buf, sizeof (buf))) < 0)
@@ -246,4 +246,5 @@
 		}
 		CF_Log_Write (LOG_SOCKET, "SERVER", "recv {%s}\n", buf);
+		CF_DEBUG_PRINT (stderr, "[SERVER] recv {%s}\n", buf);
 
 		if (CF_Socket_Send (clntsock, buf, recvd) < 0)
@@ -252,4 +253,5 @@
 		}
 		CF_Log_Write (LOG_SOCKET, "SERVER", "resp {%s}\n", buf);
+		CF_DEBUG_PRINT (stderr, "[SERVER] resp {%s}\n", buf);
 	}
 
@@ -278,5 +280,5 @@
 	CF_Log_Write (LOG_SOCKET, "CLIENT", "connected\n");
 
-	for (i = 0 ; i < 100 ; i++)
+	for (i = 0 ; i < 10 ; i++)
 	{
 		if (CF_Socket_Send (sock, buf, sizeof (buf)) < 0)
@@ -286,4 +288,5 @@
 		}
 		CF_Log_Write (LOG_SOCKET, "CLIENT", "sent {%s}\n", buf);
+		CF_DEBUG_PRINT (stderr, "[CLIENT] sent {%s}\n", buf);
 
 		memset (buf, 0x00, sizeof (buf));
@@ -295,4 +298,5 @@
 		}
 		CF_Log_Write (LOG_SOCKET, "CLIENT", "recv {%s}\n", buf);
+		CF_DEBUG_PRINT (stderr, "[CLIENT] recv {%s}\n", buf);
 	}
 
@@ -387,13 +391,12 @@
 	size_t length = 0;
 
-	CF_DEBUG_PRINT (stderr, " = Convert binary to hex = \n");
+	CF_DEBUG_PRINT (stderr, "data   : %s\n", data);
+	CF_DEBUG_PRINT (stderr, "= Convert binary to hex =\n");
 	CF_Codec_BinaryToHex ((unsigned char *)data, strlen (data), hex);
-	CF_DEBUG_PRINT (stderr, "data : %s\n", data);
-	CF_DEBUG_PRINT (stderr, "hex : %s\n", hex);
-	CF_DEBUG_PRINT_BIN (stderr, (unsigned char *) data, strlen (data), "data : %s\n", data);
-
-	CF_DEBUG_PRINT (stderr, " = Convert hex to binary = \n");
+	CF_DEBUG_PRINT (stderr, "hex    : %s\n", hex);
+	CF_DEBUG_PRINT_BIN (stderr, (unsigned char *) data, strlen (data), "data   : %s\n", data);
+
+	CF_DEBUG_PRINT (stderr, "= Convert hex to binary =\n");
 	CF_Codec_HexToBinary (hex, bin, &length);
-	CF_DEBUG_PRINT (stderr, "bin : %s\n", bin);
-	CF_DEBUG_PRINT_BIN (stderr, bin, length, "bin : %s\n", bin);
-}
+	CF_DEBUG_PRINT_BIN (stderr, bin, length, "bin    : %s\n", bin);
+}