Index: /trunk/include/cf_base.h
===================================================================
--- /trunk/include/cf_base.h	(revision 72)
+++ /trunk/include/cf_base.h	(revision 73)
@@ -3,4 +3,8 @@
  * @author	myusgun <myusgun@gmail.com>
  * @version	0.1
+ *
+ * @remarks 기본 정의
+ *
+ * @example test.c
  *
  * @mainpage
Index: /trunk/include/cf_codec.h
===================================================================
--- /trunk/include/cf_codec.h	(revision 72)
+++ /trunk/include/cf_codec.h	(revision 73)
@@ -3,6 +3,5 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remark
- * 데이터 변환 기능 제공
+ * @remark 데이터 변환
  *
  * @example codec.c
@@ -33,3 +32,3 @@
 #endif
 
-#endif // #ifndef __CF_DEBUG_H__
+#endif // #ifndef __CF_CODEC_H__
Index: /trunk/include/cf_error.h
===================================================================
--- /trunk/include/cf_error.h	(revision 72)
+++ /trunk/include/cf_error.h	(revision 73)
@@ -2,4 +2,6 @@
  * @file	cf_error.h
  * @author	myusgun <myusgun@gmail.com>
+ *
+ * @remarks 오류코드 모음
  */
 #ifndef __CF_ERROR_H__
Index: /trunk/include/cf_file.h
===================================================================
--- /trunk/include/cf_file.h	(revision 72)
+++ /trunk/include/cf_file.h	(revision 73)
@@ -2,4 +2,6 @@
  * @file	cf_file.h
  * @author	myusgun <myusgun@gmail.com>
+ *
+ * @remarks 파일 I/O
  *
  * @example file.c
Index: /trunk/include/cf_socket.h
===================================================================
--- /trunk/include/cf_socket.h	(revision 72)
+++ /trunk/include/cf_socket.h	(revision 73)
@@ -3,5 +3,5 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remark TCP 소켓만 지원됨
+ * @remark TCP 소켓 지원
  *
  * @example socket_server.c
Index: /trunk/makeinclude/platform.mk
===================================================================
--- /trunk/makeinclude/platform.mk	(revision 73)
+++ /trunk/makeinclude/platform.mk	(revision 73)
@@ -0,0 +1,153 @@
+#------------------------------------------------------------
+# set command to check os
+#------------------------------------------------------------
+UNAME_S := $(shell uname -s)
+UNAME_M := $(shell uname -m)
+UNAME_R := $(shell uname -r)
+UNAME_V := $(shell uname -v)
+UNAME_A := $(shell uname -a)
+
+#------------------------------------------------------------
+# set options
+#------------------------------------------------------------
+ifeq ($(DEBUG), true)
+	DEFS = -D_DEBUG
+	FLAG = -g
+else
+	DEFS = 
+	FLAG = -O2
+endif
+
+EXT_SHARED	= so
+EXT_STATIC	= a
+
+#------------------------------------------------------------
+# set platform
+#------------------------------------------------------------
+ifeq ($(UNAME_S), SunOS)
+	ifeq ($(UNAME_M), i86pc)
+		UNAME_S := $(UNAME_S)_x86
+		ifeq ($(VER), 32)
+			OS_DEF = solaris_x86
+		else
+			OS_DEF = solaris_x86_64
+		endif
+	else
+		ifeq ($(VER), 32)
+			OS_DEF = solaris
+		else
+			OS_DEF = solaris64
+		endif
+	endif
+endif
+
+ifeq ($(UNAME_S), AIX)
+	ifeq ($(VER), 32)
+		OS_DEF = aix
+	else
+		OS_DEF = aix64
+	endif
+endif
+
+ifeq ($(UNAME_S), HP-UX)
+	ifeq ($(UNAME_M), ia64)
+		UNAME_S := HP-UX_IA
+		ifeq ($(VER), 32)
+			OS_DEF = hp_ia
+		else
+			OS_DEF = hp_ia64
+		endif
+	else
+		ifeq ($(VER), 32)
+			OS_DEF = hp
+		else
+			OS_DEF = hp64
+		endif
+	endif
+endif
+
+ifeq ($(UNAME_S), Linux)
+	ifeq ($(UNAME_M), ppc64)
+		OS_DEF = linux_ppc64
+	else
+		ifeq ($(VER), 32)
+			OS_DEF = linux
+		else
+			OS_DEF = linux_x86_64
+		endif
+	endif
+endif
+
+ifeq ($(filter $(UNAME_A),CYGWIN),CYGWIN)
+	# forced
+	VER			= 32
+	EXT_SHARED	= dll
+	EXT_STATIC	= lib
+
+	# run as linux
+	OS_DEF		= linux
+endif
+
+#------------------------------------------------------------
+# set build env.
+#------------------------------------------------------------
+ifeq ($(OS_DEF), $(filter $(OS_DEF),solaris solaris_64 solaris_x86 solaris_x86_64))
+CC				= gcc
+LD				= gcc
+AR				= ar
+CDEFS			= $(DEFS) -D_SOLARIS -D_REENTRANT
+CFLAGS			= $(FLAG) -m$(VER) -Wall -Wconversion -Wpointer-arith -Wcast-align -fPIC
+LDFLAGS			= -m$(VER) -G -lnsl
+SHARED_FLAGS	= $(LDFLAGS) -shared
+ARFLAGS			= rc
+endif
+
+ifeq ($(OS_DEF), $(filter $(OS_DEF),aix aix64))
+CC				= cc_r
+LD				= ld
+AR				= 
+CDEFS			= $(DEFS) -D_AIX -D_REENTRANT
+CFLAGS			= $(FLAG) -q$(VER) -qcpluscmt
+LDFLAGS			= -b$(VER) -lc -brtl
+SHARED_FLAGS	= $(LDFLAGS) -bnoentry -bM:SRE
+ARFLAGS			= 
+endif
+
+ifeq ($(OS_DEF), $(filter $(OS_DEF),hp hp64 hp_ia hp_ia64))
+CC				= cc
+LD				= ld
+AR				= 
+CDEFS			= $(DEFS) -D_HPUX -D_REENTRANT
+CFLAGS			= $(FLAG) +z -q -n +w1 -Ae -z
+LDFLAGS			= -b +vallcompatwarnings
+SHARED_FLAGS	= $(LDFLAGS) +s -B symblic
+ARFLAGS			= 
+
+	ifeq ($(OS_DEF), hp)
+		CFLAGS		+= +DAportable
+		EXT_SHARED	= sl
+	endif
+
+	ifeq ($(OS_DEF), hp64)
+		CFLAGS		+= +DA2.0W
+		EXT_SHARED	= sl
+	endif
+
+	ifeq ($(OS_DEF), hp_ia)
+	endif
+
+	ifeq ($(OS_DEF), hp_ia64)
+		CFLAGS	+= +DD64
+	endif
+endif
+
+ifeq ($(OS_DEF), $(filter $(OS_DEF),linux linux_x86_64 linux_ppc64))
+CC				= gcc
+LD				= gcc
+AR				= ar
+CDEFS			= $(DEFS) -D_LINUX -D_REENTRANT
+CFLAGS			= $(FLAG) -m$(VER) -Wall -Wconversion -Wpointer-arith -Wcast-align -fPIC
+LDFLAGS			= -m$(VER) -Wl,-Bsymbolic
+SHARED_FLAGS	= $(LDFLAGS) -shared
+ARFLAGS			= rc
+endif
Index: /trunk/makeinclude/userdefine.mk
===================================================================
--- /trunk/makeinclude/userdefine.mk	(revision 73)
+++ /trunk/makeinclude/userdefine.mk	(revision 73)
@@ -0,0 +1,5 @@
+#------------------------------------------------------------
+# user define
+#------------------------------------------------------------
+VER		= 64
+DEBUG	= true
Index: /trunk/src/cf_codec.c
===================================================================
--- /trunk/src/cf_codec.c	(revision 72)
+++ /trunk/src/cf_codec.c	(revision 73)
@@ -28,5 +28,7 @@
  * @param hex	16진수 문자열을 저장할 주소
  *
- * @remark 16진수 문자열을 저장할 메모리가 미리 할당되어야 하며, 크기는 len * 2 + 1
+ * @remark
+ * 16진수 문자열을 저장할 메모리가 미리 할당되어야 하며, <br />
+ * 크기는 null-character를 포함하여 len * 2 + 1
  */
 int
@@ -67,5 +69,7 @@
  * @param len	바이너리 데이터의 길이를 저장할 주소
  *
- * @remark 바이너리 데이터를 저장할 메모리가 미리 할당되어야 하며, 크기는 strlen (hex) / 2
+ * @remark
+ * 바이너리 데이터를 저장할 메모리가 미리 할당되어야 하며, <br />
+ * 크기는 strlen (hex) / 2
  */
 int
Index: /trunk/src/makefile
===================================================================
--- /trunk/src/makefile	(revision 72)
+++ /trunk/src/makefile	(revision 73)
@@ -2,34 +2,6 @@
 # platform
 #----------------------------------------------------------
-PLATFORM	= 64
-DEBUG		= true
-
-#----------------------------------------------------------
-# load system info
-#----------------------------------------------------------
-ifeq ($(PLATFORM), 64)
-	PLATFORM	= -m64
-else
-	PLATFORM	= -m32
-endif
-
-UNAME_A		:= $(shell uname -a)
-EXT_SHARED	= so
-EXT_STATIC	= a
-
-ifeq ($(findstring CYGWIN,$(UNAME_A)),CYGWIN)
-	# forced
-	PLATFORM	= -m32
-	EXT_SHARED	= dll
-	EXT_STATIC	= lib
-endif
-
-ifeq ($(DEBUG), true)
-	DEFS = -D_DEBUG
-	FLAG = -g
-else
-	DEFS = 
-	FLAG = 
-endif
+include ../makeinclude/userdefine.mk
+include ../makeinclude/platform.mk
 
 #----------------------------------------------------------
@@ -45,13 +17,4 @@
 
 TARGET_NAME		= cf
-
-CC				= gcc
-LD				= gcc
-AR				= ar
-CDEFS			= $(DEFS) -DLINUX -DUNIX -DMTHREAD -D_REENTRANT
-CFLAGS			= $(PLATFORM) $(FLAG) -Wall -Wconversion -Wpointer-arith -Wcast-align -fPIC
-LDFLAGS			= $(PLATFORM) -Wl,-Bsymbolic
-SHARED_FLAGS	= $(LDFLAGS) -shared
-ARFLAGS			= rc
 
 SOURCE_TYPE		= c
Index: /trunk/test/makefile
===================================================================
--- /trunk/test/makefile	(revision 72)
+++ /trunk/test/makefile	(revision 73)
@@ -2,36 +2,6 @@
 # platform
 #----------------------------------------------------------
-PLATFORM	= 64
-DEBUG		= true
-
-#----------------------------------------------------------
-# load system info
-#----------------------------------------------------------
-ifeq ($(PLATFORM), 64)
-	PLATFORM	= -m64
-else
-	PLATFORM	= -m32
-endif
-
-UNAME_A		:= $(shell uname -a)
-EXT_EXECUTE	= ex
-EXT_SHARED	= so
-EXT_STATIC	= a
-
-ifeq ($(findstring CYGWIN,$(UNAME_A)),CYGWIN)
-	# forced
-	PLATFORM	= -m32
-	EXT_EXECUTE = exe
-	EXT_SHARED	= dll
-	EXT_STATIC	= lib
-endif
-
-ifeq ($(DEBUG), true)
-	DEFS = -D_DEBUG
-	FLAG = -g
-else
-	DEFS = 
-	FLAG = 
-endif
+include ../makeinclude/userdefine.mk
+include ../makeinclude/platform.mk
 
 #----------------------------------------------------------