Index: /trunk/include/cf_codec.h
===================================================================
--- /trunk/include/cf_codec.h	(revision 85)
+++ /trunk/include/cf_codec.h	(revision 86)
@@ -19,12 +19,12 @@
 
 CF_EXPORT int
-CF_Codec_BinaryToHex		(const unsigned char	* bin,
-							 const size_t			len,
-							 char					* hex);
+CF_Codec_Hex_Encode		(const unsigned char	* bin,
+						 const size_t			len,
+						 char					* hex);
 
 CF_EXPORT int
-CF_Codec_HexToBinary		(const char		* hex,
-							 unsigned char	* bin,
-							 size_t			* len);
+CF_Codec_Hex_Decode		(const char		* hex,
+						 unsigned char	* bin,
+						 size_t			* len);
 
 #ifdef __cplusplus
Index: /trunk/include/cf_file.h
===================================================================
--- /trunk/include/cf_file.h	(revision 85)
+++ /trunk/include/cf_file.h	(revision 86)
@@ -15,10 +15,10 @@
 /** 파일 열기 옵션 플래그 */
 typedef enum {
-	CF_FILE_RO = O_RDONLY,	/**< 읽기 전용 */
-	CF_FILE_WO = O_WRONLY,	/**< 쓰기 전용 */
-	CF_FILE_WR = O_RDWR,	/**< 읽기/쓰기 */
-	CF_FILE_CR = O_CREAT,	/**< 파일이 존재하지 않으면 생성 */
-	CF_FILE_TR = O_TRUNC,	/**< 파일이 존재하면 비우기 */
-	CF_FILE_AP = O_APPEND	/**< 파일이 존재하면 이어서 쓰기 */
+	CF_FILE_READ	= O_RDONLY,	/**< 읽기 전용 */
+	CF_FILE_WRITE	= O_WRONLY,	/**< 쓰기 전용 */
+	CF_FILE_RW		= O_RDWR,	/**< 읽기/쓰기 */
+	CF_FILE_CREATE	= O_CREAT,	/**< 파일이 존재하지 않으면 생성 */
+	CF_FILE_TRUNC	= O_TRUNC,	/**< 파일이 존재하면 비우기 */
+	CF_FILE_APPEND	= O_APPEND	/**< 파일이 존재하면 이어서 쓰기 */
 } E_CF_FILE_FLAG, CF_FILE_FLAG;
 
Index: /trunk/src/cf_codec.c
===================================================================
--- /trunk/src/cf_codec.c	(revision 85)
+++ /trunk/src/cf_codec.c	(revision 86)
@@ -33,7 +33,7 @@
  */
 int
-CF_Codec_BinaryToHex (const unsigned char	* bin,
-					  const size_t			len,
-					  char					* hex)
+CF_Codec_Hex_Encode (const unsigned char	* bin,
+					 const size_t			len,
+					 char					* hex)
 {
 	size_t		iter = 0;
@@ -74,7 +74,7 @@
  */
 int
-CF_Codec_HexToBinary (const char	* hex,
-					  unsigned char	* bin,
-					  size_t		* len)
+CF_Codec_Hex_Decode (const char		* hex,
+					 unsigned char	* bin,
+					 size_t			* len)
 {
 	int		result = 0;
Index: /trunk/src/cf_file.c
===================================================================
--- /trunk/src/cf_file.c	(revision 85)
+++ /trunk/src/cf_file.c	(revision 86)
@@ -91,5 +91,5 @@
 	ASSERT_ARGS (path == NULL);
 
-	result = open (path, CF_FILE_CR|CF_FILE_WO|CF_FILE_TR, FILE_MODE);
+	result = open (path, CF_FILE_CREATE|CF_FILE_WRITE|CF_FILE_TRUNC, FILE_MODE);
 
 	if (result < 0)
Index: /trunk/src/cf_log.c
===================================================================
--- /trunk/src/cf_log.c	(revision 85)
+++ /trunk/src/cf_log.c	(revision 86)
@@ -5,4 +5,7 @@
 #if defined(_WIN32) || defined(_WIN64)
 # define _USE_32BIT_TIME_T
+# if (_MSC_VER >= 1400)
+#  define localtime		_localtime32
+# endif
 #endif
 
Index: /trunk/test/codec.c
===================================================================
--- /trunk/test/codec.c	(revision 85)
+++ /trunk/test/codec.c	(revision 86)
@@ -18,10 +18,10 @@
 	CF_DEBUG_PRINT (stderr, "data   : %s\n", data);
 	CF_DEBUG_PRINT (stderr, "= Convert binary to hex =\n");
-	CF_Codec_BinaryToHex ((unsigned char *)data, strlen (data), hex);
+	CF_Codec_Hex_Encode ((unsigned char *)data, strlen (data), hex);
 	CF_DEBUG_PRINT (stderr, "hex    : %s\n", hex);
 	CF_DEBUG_PRINT_BIN (stderr, (unsigned char *) data, strlen (data), "data   : %s\n", data);
 
 	CF_DEBUG_PRINT (stderr, "= Convert hex to binary =\n");
-	CF_Codec_HexToBinary (hex, bin, &length);
+	CF_Codec_Hex_Decode (hex, bin, &length);
 	CF_DEBUG_PRINT_BIN (stderr, bin, length, "bin    : %s\n", bin);
 
Index: /trunk/test/file.c
===================================================================
--- /trunk/test/file.c	(revision 85)
+++ /trunk/test/file.c	(revision 86)
@@ -30,5 +30,5 @@
 	CF_File_Close (fd);
 
-	fd = CF_File_Open (name, CF_FILE_RO);
+	fd = CF_File_Open (name, CF_FILE_READ);
 	if (fd < 0) {
 		// error
Index: /trunk/test/test.c
===================================================================
--- /trunk/test/test.c	(revision 85)
+++ /trunk/test/test.c	(revision 86)
@@ -174,5 +174,5 @@
 	char	buffer[128] = {0x00,};
 
-	fd = CF_File_Open (file, CF_FILE_RO);
+	fd = CF_File_Open (file, CF_FILE_READ);
 	if (fd < 0)
 		CF_DEBUG_PRINT (stderr, "what the ... file open ?\n");
@@ -393,10 +393,10 @@
 	CF_DEBUG_PRINT (stderr, "data   : %s\n", data);
 	CF_DEBUG_PRINT (stderr, "= Convert binary to hex =\n");
-	CF_Codec_BinaryToHex ((unsigned char *)data, strlen (data), hex);
+	CF_Codec_Hex_Encode ((unsigned char *)data, strlen (data), hex);
 	CF_DEBUG_PRINT (stderr, "hex    : %s\n", hex);
 	CF_DEBUG_PRINT_BIN (stderr, (unsigned char *) data, strlen (data), "data   : %s\n", data);
 
 	CF_DEBUG_PRINT (stderr, "= Convert hex to binary =\n");
-	CF_Codec_HexToBinary (hex, bin, &length);
+	CF_Codec_Hex_Decode (hex, bin, &length);
 	CF_DEBUG_PRINT_BIN (stderr, bin, length, "bin    : %s\n", bin);
 }