Index: /trunk/src/cf_codec.c
===================================================================
--- /trunk/src/cf_codec.c	(revision 88)
+++ /trunk/src/cf_codec.c	(revision 89)
@@ -14,14 +14,11 @@
 
 const static unsigned char g_ascii_HexDecode[] = {
-#define ASCN	'0'	/* ascii number */
-#define ASCU	'A' /* ascii upper */
-#define ASCL	'a' /* ascii lower */
 	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  00 -  15 */
 	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  16 -  31 */
 	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  32 -  47 */
-	ASCN,ASCN,ASCN,ASCN,ASCN,ASCN,ASCN,ASCN,ASCN,ASCN,0x00,0x00,0x00,0x00,0x00,0x00,	/*  48 -  63 */
-	0x00,ASCU,ASCU,ASCU,ASCU,ASCU,ASCU,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  64 -  79 */
+	 '0', '0', '0', '0', '0', '0', '0', '0', '0', '0',0x00,0x00,0x00,0x00,0x00,0x00,	/*  48 -  63 */
+	0x00, 'A', 'A', 'A', 'A', 'A', 'A',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  64 -  79 */
 	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  80 -  95 */
-	0x00,ASCL,ASCL,ASCL,ASCL,ASCL,ASCL,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  96 - 111 */
+	0x00, 'a', 'a', 'a', 'a', 'a', 'a',0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/*  96 - 111 */
 	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	/* 112 - 127 */
 	/* end of ascii character */
@@ -50,21 +47,21 @@
 
 const static unsigned char g_ascii_Base64Decode[] = {
-	99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,	/*  00 -  15 */
-	99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,	/*  16 -  31 */
-	99,99,99,99,99,99,99,99,99,99,99,62,99,99,99,63,	/*  32 -  47 */
-	52,53,54,55,56,57,58,59,60,61,99,99,99,64,99,99,	/*  48 -  63 */
-	99, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,	/*  64 -  79 */
-	15,16,17,18,19,20,21,22,23,24,25,99,99,99,99,99,	/*  80 -  95 */
-	99,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,	/*  96 - 111 */
-	41,42,43,44,45,46,47,48,49,50,51,99,99,99,99,99,	/* 112 - 127 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/*  00 -  15 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/*  16 -  31 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,  62,0xff,0xff,0xff,  63,	/*  32 -  47 */
+	  52,  53,  54,  55,  56,  57,  58,  59,  60,  61,0xff,0xff,0xff,  64,0xff,0xff,	/*  48 -  63 */
+	0xff,   0,   1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14,	/*  64 -  79 */
+	  15,  16,  17,  18,  19,  20,  21,  22,  23,  24,  25,0xff,0xff,0xff,0xff,0xff,	/*  80 -  95 */
+	0xff,  26,  27,  28,  29,  30,  31,  32,  33,  34,  35,  36,  37,  38,  39,  40,	/*  96 - 111 */
+	  41,  42,  43,  44,  45,  46,  47,  48,  49,  50,  51,0xff,0xff,0xff,0xff,0xff,	/* 112 - 127 */
 	/* end of ascii character */
-	99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,	/* 128 - 143 */
-	99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,	/* 144 - 159 */
-	99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,	/* 160 - 175 */
-	99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,	/* 176 - 191 */
-	99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,	/* 192 - 207 */
-	99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,	/* 208 - 223 */
-	99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,	/* 224 - 239 */
-	99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,	/* 240 - 255 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 128 - 143 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 144 - 159 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 160 - 175 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 176 - 191 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 192 - 207 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 208 - 223 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 224 - 239 */
+	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,	/* 240 - 255 */
 };
 
@@ -155,5 +152,5 @@
 		if (buf)									\
 			val |=	(unsigned char)					\
-					(buf - asciiHex + (asciiHex == ASCN ? 0 : 10));	\
+					(buf - asciiHex + (asciiHex == '0' ? 0 : 10));	\
 		else										\
 			return CF_ERROR_CODEC_NOT_HEXSTRING;	\